using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.ComponentModel;

namespace ConsoleApp1
{
    public static class Data
    {
        public static List<Konyv> Konyvek = new List<Konyv>();
    }
    public class Konyv
    {
        public string cim;
        public string szerzo;
        public int ar;
        public Konyv(string Cim, string Szerzo, int Ar) {
            cim = Cim;
            szerzo = Szerzo;
            ar = Ar;
        }
    }
    internal class Program
    {
        static void Main(string[] args)
        {
            string filepath = "C:\\Users\\szabomarton\\Desktop\\ProgaOra\\20240925\\konyvek.csv";
            DataRead(filepath);
            AFeladat();
            BFeladat();
            CFeladat();

        }

        public static void CFeladat()
        {
            List<Konyv> legdragabbak = Legdragabbak(Data.Konyvek);
            Console.WriteLine("A legdrágább könyvek a következők:");
            foreach (var item in legdragabbak)
            {
                Console.WriteLine($"\t{item.cim}, {item.ar}");
            }
        }

        public static List<Konyv> Legdragabbak(List<Konyv> konyvek)
        {
            return konyvek.OrderByDescending(x => x.ar).Take(5).ToList();
        }

        public static void BFeladat()
        {
            int num = Ketezerfelettiek(Data.Konyvek);
            Console.WriteLine($"A kétezer forint fölötti könyvek száma: {num}"); 
        }

        public static int Ketezerfelettiek(List<Konyv> konyvek)
        {
            return konyvek.Where(x => x.ar > 2000).Count();
        }

        public static void AFeladat()
        {
            Console.WriteLine("A könyvtár tartalma: ");
            foreach (var item in Data.Konyvek)
            {
                Console.WriteLine($"\t{item.cim}, {item.szerzo}, {item.ar}");
            }
        }


        public static void DataRead(string path)
        {
            using (StreamReader streamReader = new StreamReader(path))
            {
                string line = streamReader.ReadLine();
                line = streamReader.ReadLine();

                while (line != null)
                {
                    string[] strings = line.Split(';');
                    int ar = Int32.Parse(strings[2]);
                    Konyv konyv = new Konyv(strings[0], strings[1], ar);
                    Data.Konyvek.Add(konyv);
                    line = streamReader.ReadLine();
                }

                streamReader.Close();
            }
        }
    }
}
